#ifndef NPCS_HPP_INCLUDED
#define NPCS_HPP_INCLUDED

#include "../../Game/Interactable/NPC.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>


/** @addtogroup Models
* @{ */
class NPCs
{
    public:

        static std::vector<Interactable::NPC> GetAllWithin(std::int32_t Distance);

        static std::vector<Interactable::NPC> GetAll();
        static std::vector<Interactable::NPC> GetAll(const Tile& T);
        static std::vector<Interactable::NPC> GetAll(std::int32_t ID, std::int32_t Distance = -1);
        static std::vector<Interactable::NPC> GetAll(const std::string& Name, std::int32_t Distance = -1);
        static std::vector<Interactable::NPC> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
        static std::vector<Interactable::NPC> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
        static std::vector<Interactable::NPC> GetAll(const std::function<bool (const Interactable::NPC&)>& Filter, std::int32_t Distance = -1);

        static Interactable::NPC Get(const Tile& T);
        static Interactable::NPC Get(std::int32_t ID, std::int32_t Distance = -1);
        static Interactable::NPC Get(const std::string& Name, std::int32_t Distance = -1);
        static Interactable::NPC Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
        static Interactable::NPC Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
        static Interactable::NPC Get(const std::function<bool (const Interactable::NPC&)>& Filter, std::int32_t Distance = -1);
};
/** @} */

#endif // NPCS_HPP_INCLUDED
